<template>
  <div>
    <div class="btn-action-container">
      <img
        :src="asset('images/ui_elements/ic_edit.png')"
        alt="icon info"
        class="btn-action"
        @click="showModal()"
      >
    </div>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
    >
      <div class="container" v-if="propsData">
        <div class="row mb-2">
          <div class="col-md-6">
            <h5>Edit Value</h5>
          </div>
          <div class="col-md-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-md-12">
            <form class="form-material" @submit.prevent="submitForm">
              <div class="form-group">
                <label>Key</label>
                <input
                  type="text"
                  class="form-control"
                  name="key"
                  v-validate="'required'"
                  placeholder="Enter Key"
                  v-model="propsData.key"
                >
                <small class="text-danger">{{ errors.first('key') }}</small>
              </div>

              <div class="form-group">
                <label>Value Type</label>
                <select class="form-control" v-model="propsData.value_type">
                  <option value="text">Text</option>
                  <option value="html">Html</option>
                </select>
              </div>

              <div class="form-group" v-show="propsData.value_type == 'text'">
                <label>Value</label>
                <input
                  type="text"
                  class="form-control"
                  name="value"
                  placeholder="Enter Value"
                  v-model="propsData.value"
                >
              </div>

              <div class="form-group" v-show="propsData.value_type == 'html'">
                <label>Value</label>
                <rich-editor v-model="propsData.value" :content="propsData.value"></rich-editor>
              </div>
              <div class="form-group">
                <label>Description</label>
                <textarea
                  v-model="propsData.description"
                  name="description"
                  v-validate="'required'"
                  class="form-control"
                ></textarea>
              </div>

              <div class="form-group">
                <label>Status</label>
                <select class="form-control" v-model="propsData.is_active">
                  <option value="true">Active</option>
                  <option value="false">Not Active</option>
                </select>
              </div>

              <button type="submit" class="btn btn-primary form-control capsule">
                <span v-if="loading">
                  Updating
                  <i class="fas fa-circle-notch fa-spin"></i>
                </span>
                <span v-else>Save</span>
              </button>
            </form>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";
import RichEditor from "@/components/general/RichEditor";

export default {
  components: { RichEditor },

  data() {
    return {
      loading: false
    };
  },
  props: ["propsData"],

  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          this.loading = true;
          let response = await this.$axios.put(
            process.env.MIX_APP_URL +
              `/api/${this.$store.getters.appId.hashed}/general-value/${
                this.propsData.id
              }`,
            { ...this.propsData }
          );

          this.hideModal();
          httpHelper.successToast(this, response.data.message);

          EventBus.$emit("refreshTable");
        } catch (error) {
          httpHelper.errorToast(this, error);
        }
      } else {
        // this.$refs.lennaModal.show('alert','Sorry','You must correct your form first')
      }
      this.loading = false;
    }
  }
};
</script>
<style lang="scss" scoped>
.nav-link.active {
  background: #dadada !important;
  color: #1d68a7;
}
.tab-propsData {
  word-wrap: break-word;
}
.image-container {
  background: #e8e8e8;
  max-height: 400px;
  & input {
    opacity: 0 !important;
    height: 100%;
    position: absolute;
    top: 0;
  }
  & img {
    max-height: 250px;
  }
}
</style>
